#ifndef CAPTURE_H
#define CAPTURE_H


class CCapturePreview;

class CCapturePreviewEvent {
protected:
	CCapturePreview *m_pCapturePreview;
public:
	CCapturePreviewEvent(CCapturePreview *pCapturePreview);
	virtual ~CCapturePreviewEvent() {}
	virtual bool OnClose() { return true; }
};

class CCapturePreview {
	static HINSTANCE m_hinst;
	HWND m_hwnd;
	HGLOBAL m_hData;
	COLORREF m_crBackColor;
	struct {
		int Left,Top;
		int Width,Height;
	} m_WindowPosition;
	CCapturePreviewEvent *m_pEvent;
	static CCapturePreview *GetThis(HWND hwnd);
	static LRESULT CALLBACK WndProc(HWND hwnd,UINT uMsg,WPARAM wParam,LPARAM lParam);
	void SetTitle();
public:
	static bool Initialize(HINSTANCE hinst);
	CCapturePreview();
	~CCapturePreview();
	bool Create(HWND hwndParent,DWORD Style,DWORD ExStyle);
	bool Destroy();
	bool SetImage(const BITMAPINFO *pbmi,const void *pBits);
	bool SetImage(HGLOBAL hData);
	bool ClearImage();
	bool HasImage() const;
	bool SetPosition(int Left,int Top,int Width,int Height);
	bool GetPosition(int *pLeft,int *pTop,int *pWidth,int *pHeight) const;
	bool SetEventHandler(CCapturePreviewEvent *pEvent);
};


#endif
